#!/bin/sh

VERSION="0.4.1"
XPI_NAME=reqmarkup-${VERSION}.xpi

# Get the directory where this script resides.
WORK_DIR=$(cd `dirname $0` && pwd)

# Clean first, build later
${WORK_DIR}/clean.sh

echo "Creating ${XPI_NAME}..."

cd ${WORK_DIR}
mkdir -p xpi
cp -r src/* xpi/

# Pack inner "jar"
cd xpi/chrome
zip -rqmT reqmarkup.jar * 

if [ $? -ne 0 ] 
then
	echo "Unable to build T2C ReqMarkup: the inner jar-file is not prepared properly."
	exit 1
fi

# Pack outer "xpi"
cd ${WORK_DIR}/xpi
zip -rqmT ${XPI_NAME} * 

if [ $? -ne 0 ] 
then
	echo "Unable to build T2C ReqMarkup: failed to create xpi file."
	exit 1 
fi

# Done
echo "${XPI_NAME} is created successfully."
