var gActiveEditor;
var reqId;
var lastIdUsed;

var reqOrigText;
var reqAltText;

var mode;
var dialogNode;

var selectedReq;
var selectedId;

var defines = new Array();  // defines[symb].strings = array(strings);
                            // defines[symb].matcher = Regexp;

function expand_subst(id, defines) {
    var ids = new Array(id);
    do {
        var subst_done = true;
        var ids_len = ids.length;
        var new_ids = new Array();
        for(var thisid=0; thisid<ids_len; thisid++ ) {
            var id = ""+ids[thisid];
            var replaced = false;
            for ( var symb in defines ) {
                if ( id.match(defines[symb].matcher) ) {
                    replaced = true;
                    subst_done = false;
                    for (var str_i in defines[symb].strings) {
                        var str = defines[symb].strings[str_i];
                        var id_tmp = id;
                        id_tmp = id_tmp.replace(defines[symb].matcher, str);
                        new_ids.push(id_tmp);
                    }
                }
            }
            if (!replaced) {
                new_ids.push(id);
            }
        }
        ids = new_ids;
    }while (!subst_done);
    return ids;
}

// dialog initialization code
function Startup(modeInput)
{
    mode = modeInput;
    
    dialogNode = document.getElementById(mode+"Dlg");
    dialogNode.getButton("extra2").label = "Delete";
    
    gActiveEditor = GetCurrentEditor();
    if (!gActiveEditor)
    {
        dump("Failed to get active editor!\n");
        window.close();
        return;
    }
    // Message was wrapped in a <label> or <div>, so actual text is a child text node
    gDialog.idInput          = document.getElementById("idInput");
    gDialog.reqOrigTextInput = document.getElementById("reqOrigTextInput");
    gDialog.reqAltTextInput  = document.getElementById("reqAltTextInput");
    gDialog.currentIds       = document.getElementById("currentIds");
    gDialog.filterExprInput  = document.getElementById("filterExprInput");

    InitDialog();
    
    gDialog.idInput.addEventListener('input', IdChanged, false);

    SetWindowLocation();
}

function InitDialog()
{
    lastIdUsed = window.arguments[0]();
    
    //<>
    //alert("[D] Last: \"" + lastIdUsed + "\"");
    //<>
    
    ClearListbox(gDialog.currentIds);
    var document = gActiveEditor.document;
    var reqList = document.getElementsByTagName("*");

    // strip tags and excessive newlines from the text.
    reqOrigText = gActiveEditor.outputToString("text/html", 1).replace(/<[^>]+>/g, "");
    reqOrigText = reqOrigText.replace(/[\n\r]+/g, " ");
    
    gDialog.reqOrigTextInput.value = reqOrigText;
    
    var lastId = "";
    for (var i = 0; i<reqList.length; i++)
    {
        if(reqList[i].className==mode)
        {
            lastId = ""+reqList[i].id;
            gDialog.currentIds.insertItemAt(0, lastId, lastId);
        }
        else if (reqList[i].className == "define") 
        {
            var symb = "" + reqList[i].name;
            var strings = "" + reqList[i].title;
            
            defines[symb] = new Object();
            defines[symb].matcher = new RegExp;
            defines[symb].matcher.compile(symb+"\\b","");
            defines[symb].strings = new Array();
            
            var strings_spl = strings.split(";");
            
            var strings_spl_len = strings_spl.length;
            for (var j=0; j<strings_spl_len; j++) {
                strings_spl[j] = strings_spl[j].replace(/(^\s+|\s+$)/g,"");
                
                if (strings_spl[j] != "")
                {
                    defines[symb].strings.push(strings_spl[j]);
                }
            } // end for j=0 ...
        }
    }
    
    if(lastIdUsed && lastIdUsed != "")
    {
        gDialog.idInput.value = lastIdUsed;
        onInc();
    }
    else if (lastId != "")
    {
        lastIdUsed = lastId;
        gDialog.idInput.value = lastIdUsed;
        onInc();
    }
    IdChanged();
}

function IdChanged()
{
    // We disable Ok button when there's no reqId text only if inserting a new REQ
    var enable = (TrimString(gDialog.idInput.value).length > 0) ? true : false;

    // anon. content, so can't use SetElementEnabledById here
    dialogNode.getButton("accept").disabled = !enable;
    dialogNode.getButton("accept").label="Add";
    dialogNode.getButton("extra2").disabled = true;
    gDialog.idInput.style.color='rgb(0, 0, 0)';
}

var letters="&abcdefghijklmnopqrstuvwxyz";
var LETTERS="&ABCDEFGHIJKLMNOPQRSTUVWXYZ";

function isAlpha(c) {
    var c = c.substring(0,1);
    // if c is alpha return true
    if(letters.indexOf(c)>=0 || LETTERS.indexOf(c)>=0) return true;
    return false;
}

function incNum(sym)
{
    var num = parseInt(sym, 10);
    IdChanged();
    if(!isNaN(num))
    {
        num++;
        var r = ""+num;
        while(r.length<sym.length) r = "0"+r;
        return r;
    }
    else return sym+"!";
}

function incReq(id)
{
    // inc the last index (if it is an index, actually)
    var ind = id.lastIndexOf("."); 
    if (ind == -1) // found no dots
    {
        return id;
    }
    
    if (ind == id.length - 1) // dot is the last symbol
    {
        return id;
    }
    
    ++ind; // start of the last group of digits
    
    var last = id.substr(ind); // the last group of digits
    var first = id.substring(0, ind); // up to the dot
    
    if (isAlpha(last))
    {
        // no digits, do nothing
        return id;
    }
    else
    {
        last = incNum(last);
    }
    
    return (first + last);
}

function onInc()
{
    var val = gDialog.idInput.value.replace(/(^\s+|\s+$)/g,"");
    var slen = val.length;
    if ((slen > 0) && (val.charAt(slen - 1) == ";"))
    {
        val = val.substr(0, slen - 1);
    }
    
    var ids = val.split(";");
    var res = "";
    for(var ii=0;ii<ids.length;ii++)
    {
        res+=incReq(ids[ii]);
        if(ii<ids.length-1)
            res+=";";
    }
    gDialog.idInput.value = res;
}

function onSelected(lb)
{   
    if (lb.getRowCount() > 0)
    {
        if (lb.selectedIndex < 0)
        {
            lb.selectedIndex = 0
        }
        
        var id = lb.childNodes[lb.selectedIndex].label;
        var document = gActiveEditor.document;
               
        selectedReq = document.getElementById(id);
        selectedId = id;
        gDialog.idInput.value = selectedId;
        
        // checking if the "form" field arrangement is correct
        if(selectedReq.lastChild.className!="form")
        {
            var childList = selectedReq.getElementsByTagName("*");
            for (var i = 0; i<childList.length; i++)
            {
                if(childList[i].className=="form")
                {
                    selectedReq.appendChild(childList[i].cloneNode(true));
                    selectedReq.removeChild(childList[i]);
                }
            }
        }
        
        gDialog.reqAltTextInput.value = "";
        gDialog.reqOrigTextInput.value = "";
        if(selectedReq.lastChild != null)
        {
            if(selectedReq.lastChild.className=="form")
            {
                gDialog.reqAltTextInput.value = selectedReq.lastChild.textContent;
            }
        }
        
        var str = selectedReq.textContent;
        var len = str.length - gDialog.reqAltTextInput.value.length;
        gDialog.reqOrigTextInput.value = str.substr(0, len);
                
        dialogNode.getButton("accept").label="Overwrite";
        dialogNode.getButton("extra2").disabled = false;
        gDialog.idInput.style.color='rgb(255, 0, 0)';
    }
}

// Strips the "app" and "ext" prefixes from the specified string
// and returns the result.
function stripPrefixes(str_id)
{
    var tstr = str_id;
    
    if (tstr.substr(0,4)=="app.")
    {
        tstr = tstr.substr(4);
        if (tstr.substr(0,4)=="ext.")
        {
            tstr = tstr.substr(4);
        }
    }
    else if (tstr.substr(0,4)=="ext.")
    {
        tstr = tstr.substr(4);
        if (tstr.substr(0,4)=="app.")
        {
            tstr = tstr.substr(4);
        }
    }
   
    return tstr;
}

// Get and validate data from widgets.
// Set attributes on globalElement so they can be accessed by AdvancedEdit()
function ValidateData()
{
    gActiveEditor = GetCurrentEditor();
    var document = gActiveEditor.document;
    var list = document.getElementsByTagName("*");
    var temp;
    var addition;
    
    if(gActiveEditor.outputToString("text/html", 1)=="")
    {
        alert("No requirement text");
        return false;
    }
    
    var idList = Array();
    for(var i = 0; i<list.length; i++)
    {
        if(list[i].className==mode)
        {
            list[i].id = list[i].id.replace(/(^\s+|\s+$)/g,"");
            
            var ids=list[i].id.split(";");
            for(var j = 0; j<ids.length; j++)
            {
                if (ids[j] != "")
                {
                    var exp_list = expand_subst(ids[j], defines);
                    for (var n = 0; n < exp_list.length; n++)
                    {
                        idList.push(exp_list[n]);
                    }
                } // if 
            } // for j
        }
    }
    
    var ids = reqId.split(";");
    for(var j = 0; j<ids.length; j++)
    {
        if (ids[j] == "") continue;
        
        if(ids[j].charAt(0)=='&')
        {
            temp = ids[j].substr(1);
            addition = true;
        }
        else
        {
            temp = ids[j];
            addition = false;
        }
        
        if(addition)
        {
            var valid = false;
            for (var i = 0; i<idList.length; i++)
            {
                if(idList[i] == temp)
                    valid = true;
            }
            if(!valid)
            {
                alert("No main "+mode+" for "+ids[j]);
                return false;
            }
        }
        else
        {
        	temp = stripPrefixes(temp);
        	
            for (var i = 0; i<idList.length; i++)
            {
                if(temp == stripPrefixes(idList[i]))
                {
                    alert("ID collision for "+ids[j]);
                    return false;
                }
            }
        }
    }

    return true;
}

function onAccept()
{
    reqId = TrimString(gDialog.idInput.value);
    reqAltText = TrimString(gDialog.reqAltTextInput.value);

    gActiveEditor = GetCurrentEditor();

    lastIdUsed = reqId;
    
    window.arguments[1](lastIdUsed);
    
    if(dialogNode.getButton("accept").label=="Overwrite")
    {
        gActiveEditor.beginTransaction();
        
        if(reqAltText != "")
        {
            if((selectedReq.lastChild == null) || (selectedReq.lastChild.className!="form"))
            {
                var newNode = document.createElement("span");
                newNode.className = "form";
                newNode.style.display = "none";
                selectedReq.appendChild(newNode);
            }
            selectedReq.lastChild.textContent = reqAltText;
        }
        else
        {
            if((selectedReq.lastChild != null) && (selectedReq.lastChild.className=="form"))
            {
                selectedReq.removeChild(selectedReq.lastChild);
                
            }
        }
        
        gActiveEditor.incrementModificationCount(1);
        gActiveEditor.endTransaction();
        
        return true;
    }
    else
    if(ValidateData())
    {
        if (reqId.length > 0)
        {
            gActiveEditor.beginTransaction();
            try {
                if (reqAltText != "")
                {
                    reqAltText = "<span class='form' style='display: none;'>"+reqAltText+"</span>";
                }
               
                gActiveEditor.insertHTML("<span class='"+mode+"' id='"+reqId+"'>"+gActiveEditor.outputToString("text/html", 1)+reqAltText+"</span>");
                
            } catch (e) {
                dump("Exception occured in insertHTML\n");
                return true;
            } finally {
                gActiveEditor.endTransaction();
            }
        } 
        SaveWindowLocation();
        return true;
    }
    return false;
}

function onDelete()
{
    if (confirm("Are you sure you want to delete this requirement?"))
    {   
        gActiveEditor = GetCurrentEditor();
        var document = gActiveEditor.document;
        
        //window.arguments[1](selectedId);
        lastIdUsed = selectedId;
        window.arguments[1](lastIdUsed);
        
        gActiveEditor.beginTransaction();
        
        try
        {
            if(selectedReq.lastChild != null)
                if(selectedReq.lastChild.className=="form")
                    selectedReq.removeChild(selectedReq.lastChild);
            
            var childNodes = selectedReq.childNodes;
            for (var ch = 0; ch < childNodes.length; ch++)
            {
                var node = childNodes[ch].cloneNode(true);
                selectedReq.parentNode.insertBefore(node, selectedReq);
            }
            
            selectedReq.parentNode.removeChild(selectedReq);
        } 
        finally
        {
            gActiveEditor.endTransaction();
            gActiveEditor.incrementModificationCount(1);
        }
        
        onFilterNow();
        IdChanged();
    }
}

function onFilterNow()
{
    gDialog.currentIds.setAttribute("suppressonselect", "true");
        
    var filterExpr = "" + gDialog.filterExprInput.value;
    
    ClearListbox(gDialog.currentIds);
    var document = gActiveEditor.document;
    var reqList = document.getElementsByTagName("*");
    
    var lastId = "";
    for (var i = 0; i<reqList.length; i++)
    {
        if(reqList[i].className==mode)
        {
            lastId = ""+reqList[i].id;
            if (lastId.match(filterExpr))
            {
                gDialog.currentIds.appendItem(lastId, lastId);
            }
        }
    }
    gDialog.currentIds.setAttribute("suppressonselect", "false");
}
