var reExtApp = new RegExp ("ext\\.|app\\.", "g");
//var reLine = new RegExp ("(.{0,71}\\S|)(\\s\\n|\\n|\\s)", "g");

var space = "&nbsp;&nbsp;&nbsp;&nbsp;";
var dspace = space+space;

var defines = new Array();  // defines[symb].strings = array(strings);
                            // defines[symb].matcher = Regexp;
var ndefines = 0;           // Number of defines (used to determine whether to show '#defines' table')

var lastId = "";

// Strips the "app" and "ext" prefixes from the specified string
// and returns the result.
function stripPrefixes(str_id)
{
    var tstr = str_id;
    
    if (tstr.substr(0,4)=="app.")
    {
        tstr = tstr.substr(4);
        if (tstr.substr(0,4)=="ext.")
        {
            tstr = tstr.substr(4);
        }
    }
    else if (tstr.substr(0,4)=="ext.")
    {
        tstr = tstr.substr(4);
        if (tstr.substr(0,4)=="app.")
        {
            tstr = tstr.substr(4);
        }
    }
   
    return tstr;
}

function sortfunc(aa,bb)
{   
    var tmpa = stripPrefixes(aa); 
    var tmpb = stripPrefixes(bb);
    return tmpa.localeCompare(tmpb);
}

function getfname(s) // returns function name for a given ID or ID reference
{
    s = s.replace(/(^\s+|\s+$)/g,""); // remove leading & trailing whitespace chars
    var c0;
    while( (c0 = s.charAt(0)) && c0=="&" || c0=="#" || c0=="$")
    {
        s=s.substr(1); // skipping [&#$]+
    }
    
    s = stripPrefixes(s);

    var i = s.indexOf(".");
    if(i<0)
        i=s.length;
    var res = s.substring(0,i); 
    
    return res;
}

// Returns true if the specified ID (or ID reference) has 'app' prefix, false otherwise 
function isApp(s)
{
    s = s.replace(/(^\s+|\s+$)/g,"");
    var c0;
    while( (c0 = s.charAt(0)) && c0=="&" || c0=="#" || c0=="$")
    {
        s=s.substr(1); // skipping [&#$]+
    }

    if (s.substr(0,4)=="ext.")
    {
        s = s.substr(4);
    }
    
    var res = s.substring(0,4); 
    if(res=="app.")
    {
        return true;
    }

    return false;
}

// if (typeof Element != 'undefined' && Element.prototype && document.createRange)
if (typeof Element != 'undefined' && typeof Element != 'function' && Element.prototype && document.createRange)  
{
   Element.prototype.__defineGetter__(
     'innerText',
     function () {
       var range = document.createRange();
       range.selectNodeContents(this);
       return range.toString();
     }
   );
   Element.prototype.__defineSetter__(
     'innerText',
     function (text) {
       var range = document.createRange();
       range.selectNodeContents(this);
       range.deleteContents();
       this.appendChild(document.createTextNode(text));
     }
   ); 
}

function expand_subst(id) {
    var ids = new Array(id);
    do {
        var subst_done = true;
        var ids_len = ids.length;
        var new_ids = new Array();
        for(var thisid=0; thisid<ids_len; thisid++ ) {
            var id = ""+ids[thisid];
            var replaced = false;
            for ( var symb in defines ) {
                if ( id.match(defines[symb].matcher) ) {
                    replaced = true;
                    subst_done = false;
                    for (var str_i in defines[symb].strings) {
                        var str = defines[symb].strings[str_i];
                        var id_tmp = id;
                        id_tmp = id_tmp.replace(defines[symb].matcher, str);
                        new_ids.push(id_tmp);
                    }
                }
            }
            if (!replaced) {
                new_ids.push(id);
            }
        }
        ids = new_ids;
    }while (!subst_done);
    return ids;
}

function getLastId()
{
    //<>
    //alert("Get " + lastId);
    //<>
    
    return lastId;
}

function setLastId(id)
{
    lastId = id;
    
    //<>
    //alert("Set " + lastId);
    //<>
}

function OpenReqDiag()
{
    window.openDialog("chrome://reqmarkup/content/EdReqProps.xul",
        "_blank", 
        "chrome,close,titlebar,modal",
        getLastId,
        setLastId);
    window.content.focus();
}

function Highlight()
{
    var gActiveEditor = GetCurrentEditor();
    var document = gActiveEditor.document;
    
    gActiveEditor.incrementModificationCount(1);
    
    var style;
    if((style=document.getElementById('reqstyle')) != null)
    {
        document.getElementsByTagName('head')[0].removeChild(style);
        return;
    }
    
    style = document.createElement('style');
    style.id = 'reqstyle';

    document.getElementsByTagName('head')[0].appendChild(style);
    var stylesheet = document.styleSheets[document.styleSheets.length - 1];
    var ownerNode = stylesheet.ownerNode;
    var textNode = document.createTextNode("\n.req { background-color: rgb(255, 255, 153);}\n");
    ownerNode.appendChild(textNode);
}

function RemoveMarkup()
{
    if (confirm("Are you sure you want to completely remove requirement markup?"))
    {   
        var gActiveEditor = GetCurrentEditor();
        var document = gActiveEditor.document;
        
        gActiveEditor.beginTransaction();
        
        try
        {
            // remove req markup
            do
            {
                var smthRemoved = false;
                
                var coll = document.getElementsByTagName("*");
                for(i = 0; i < coll.length; i++)
                {
                    var nreq = coll[i];

                    if(nreq.className=="req")
                    {
                        if(nreq.lastChild != null)
                        {
                            if(nreq.lastChild.className=="form")
                            {
                                nreq.removeChild(nreq.lastChild);
                            }
                        }
                        
                        var childNodes = nreq.childNodes;
                        for (var ch = 0; ch < childNodes.length; ch++)
                        {
                            var node = childNodes[ch].cloneNode(true);
                            nreq.parentNode.insertBefore(node, nreq);
                        }
                        nreq.parentNode.removeChild(nreq);
                        
                        smthRemoved = true;
                    }
                    else if (nreq.className=="define")
                    {
                        nreq.parentNode.removeChild(nreq);
                    }
                }
            } 
            while (smthRemoved);
            
            //remove code template
            var tmpl = document.getElementById("template");
            if (tmpl)
            {
                tmpl.parentNode.removeChild(tmpl);
            }
            
            //remove req style
            var rstl = document.getElementById("reqstyle");
            if (rstl)
            {
                rstl.parentNode.removeChild(rstl);
            }
        }
        finally
        {
            gActiveEditor.incrementModificationCount(1);
            gActiveEditor.endTransaction();
        }
    }
}

// [?] Why do we need to sort these?
// This function is used in GenerateTemplate only
function reqSort0(a, b)
{
    var tempa = a;
    var tempb = b;
    
    // don't take "ext." and "app." prefixes into account here (just strip them).
    tempa = tempa.replace(reExtApp, "");
    tempb = tempb.replace(reExtApp, "");
    
    if(String(tempa) < String(tempb))
        return -1;
    if(String(tempa) > String(tempb))
        return 1;
    return 0;
}

function reqShow()
{
    var gActiveEditor = GetCurrentEditor();
    var document = gActiveEditor.document;
        
    //
    var allReqs = new Array();
    
    var globIDsCollision = false;

    // First pass. Gathering reqs.
    var coll = document.getElementsByTagName("*"); 
    if (!coll) return;
    
    gActiveEditor.incrementModificationCount(1);
    
    var clen = coll.length;
    for (i=0; i<clen; i++)
    { 
        if (i == clen - 1) clen = coll.length; // coll.length changes dynamicaly
        
        var c = coll[i];

        if (c.className == "define") 
        {
            var symb = "" + c.name;
            var strings = "" + c.title;
            
            ndefines++;
            defines[symb] = new Object();
            defines[symb].matcher = new RegExp;
            defines[symb].matcher.compile(symb+"\\b","");
            defines[symb].strings = new Array();
            
            var strings_spl = strings.split(";");
            
            var strings_spl_len = strings_spl.length;
            for (var j=0; j<strings_spl_len; j++) {
                strings_spl[j] = strings_spl[j].replace(/(^\s+|\s+$)/g,"");
                
                if (strings_spl[j] != "")
                {
                    defines[symb].strings.push(strings_spl[j]);
                }
            } // end for j=0 ...
        }
        
        if(c.className == "req")
        {
            var title = "" + c.title;
            var ids = new Array();
            
            var str_id = "" + c.id;
            str_id = str_id.replace(/(^\s+|\s+$)/g,"");
            
            var slen = str_id.length;
            if ((slen > 0) && (str_id.charAt(slen - 1) == ";"))
            {
                str_id = str_id.substr(0, slen - 1);
            }
            
            ids = str_id.split(";");
            
            // subst
            var new_ids = new Array();
            for (var thisid in ids) 
            {
                var id = ""+ids[thisid];
                var expanded_id = expand_subst(id)
                new_ids = new_ids.concat(expanded_id);
            }
            ids = new_ids;
            
            // requirement text & its alternative formulation
            var origFormText = getElementText(c);
            if (!origFormText) origFormText = "";
            
            var lastCh = c.lastChild;
            var altFormText = "";
            
            if (lastCh.className=="form")
            {
                altFormText = getElementText(lastCh);
                if(altFormText != null)
                {
                    altFormText = altFormText.replace(/[\n\r]+/g, " ");
                }
                else
                {
                    altFormText = "";
                }
            }
            
            origFormText = origFormText.substr(0, origFormText.length - altFormText.length);
            
            var ids_len = ids.length;
            for(var thisid = 0; thisid < ids_len; thisid++ ) // ids
            {
                var id = "" + ids[thisid];
                var tmp_id = id;
                var IDsCollision = false;

                var doubled = false;
                var c0;
                while( (c0 = tmp_id.charAt(0)) && c0=="!" || c0=="?" || c0=="&" || c0=="$" ) {
                    if(c0 == "&") doubled = true;
                    tmp_id = tmp_id.substr(1);
                }
                
                if(allReqs[tmp_id]) // checking collisions
                {
                    if(!doubled)
                    {
                        //while(allReqs[id]) id = "+"+id;
                        IDsCollision = true; // for this req
                        globIDsCollision = true; // global header alert
                        allReqs[tmp_id].IDsCollision = true;
                    }
                }
                
                if (id == "") // checking if the id is empty 
                {
                    IDsCollision = true; // for this req
                    globIDsCollision = true; // global header alert
                    /*id = "Empty ID!";
                    while(allReqs[id])
                    {
                        id = id + "!";
                    }*/
                }
                
                if(!doubled)
                {
                    allReqs[id]         = new Object(); // creating new REQ
                    allReqs[id].id      = id;
                    //allReqs[id].pos       = thisid;
                    allReqs[id].c       = c;
                    //allReqs[id].origHTML= c.innerHTML;
                    allReqs[id].title           = c.title;
                    allReqs[id].IDsCollision    = IDsCollision;
                    allReqs[id].altFormText     = altFormText;
                    allReqs[id].origFormText    = origFormText;
                }
            } // end of ids
        } // end of if classname = req
    } // end of first walk
    /* Now we have allReqs[elem_id] - array of reqs. */
    
    // Second pass. Making children-parent references.
    for(var id in allReqs)
    {
        var probParentId = id.substring(0, id.lastIndexOf("."));

        if(allReqs[probParentId])
        {
            allReqs[id].parentId = probParentId;
            if(!allReqs[probParentId].children)
                allReqs[probParentId].children = new Array(); // array of id's
            allReqs[probParentId].children.push(id);
        }
    }
    /* Now all elements of allReqs[] have .parentId and .children[child_id] */
    
    // Third pass: templates.
    var template = document.createElement('div');
    template.id = 'template';
    template.style.color= 'rgb(0, 0, 192)';
    document.body.insertBefore(template, document.body.firstChild);
    
    // sorting
    reqSort = new Array();
    for(var id in allReqs)
    {
        reqSort.push(id);
    }
    reqSort = reqSort.sort(sortfunc);
    
    // splitting by funcname
    reqSplit = new Array();
    for(var id in allReqs)
    {
        var fname = getfname(id);
        if(!reqSplit[fname])
        {
            reqSplit[fname] = new Array();
        }
        
        reqSplit[fname].push(id);
    }   
    var reqSplitSort = new Array();
    for(var fname in reqSplit)
    {
        reqSplitSort.push(fname);
    }
    
    reqSplitSort = reqSplitSort.sort();
    
    for(var i in reqSort)
    {
        var id = reqSort[i];
        var elem = allReqs[id];
        
        if (elem.c.id == "")
        {
            alert ("Empty ID found!");
            return;
        }
        
        if (elem.IDsCollision)
        {
            alert ("ID collision: " + elem.id);
            return;
        }
    }
    
    // ----------------------------------------------------
    // resCodeTemplatePre/Post generation. (Template Pre/Post)
    var text = "<code>";
    for(var i in reqSplitSort)
    {
        var fname = reqSplitSort[i];
        
        text += "&lt;BLOCK&gt;<br><br>&lt;TARGETS&gt;<br>" + space;
        text += fname;
        text += "<br>&lt;/TARGETS&gt;<br><br>&lt;DEFINE&gt;<br>&lt;/DEFINE&gt;<br><br>&lt;CODE&gt;<br><br>";
        
        var resCodeTemplatePre = "";
        var resCodeTemplatePost = "";
        
        var ids = reqSplit[fname];
        ids = ids.sort();
        for(var j in ids) // for a given target interface...
        {
            id = ids[j];
            var elem = allReqs[id];

            if(!elem.children)
            {
                var reqTemplate = space + "/*<br>";
                if (elem.origFormText != "")    
                {
                    // display the original requirement text in the comment
                    reqTemplate += formatCommentText (elem.origFormText);

                }
                
                if (elem.altFormText != "")    
                {
                    // display the alternative requirement text in the comment
                    if (elem.origFormText != "") 
                    {
                        reqTemplate += space + "&nbsp;*<br>";
                    }
                    reqTemplate += formatCommentText ("[" + elem.altFormText + "]");
                }
                
                reqTemplate += space + "&nbsp;*/<br><br>";
                
                var stub = "TODO_REQ()";
                
                //reqTemplate += formatParents(allReqs, id, dspace); 
                // REQ("id",..,..);
                reqTemplate += space + "REQ(\"" + id + "\", \"\", " + stub + ");<br><br>";
                
                if(isApp(elem.id))
                {
                    resCodeTemplatePre += reqTemplate;
                }
                else // no "app" prefix
                {
                    resCodeTemplatePost += reqTemplate;
                } // end if isApp
            } //end if (there are no children)
        } // end for j in ...
        
        text += resCodeTemplatePre;
        text += resCodeTemplatePost;
        
        text += "&lt;/CODE&gt;<br><br>&lt;PURPOSE&gt;<br>&lt;/PURPOSE&gt;<br><br>&lt;/BLOCK&gt;<br>"
        text += "<br>#===============================================================================<br><br>";
    }
    text += "</code>";
    
    template.innerHTML=text;
    
    // end of resCodeTemplatePre/Post generation. (Template Pre/Post)
    // ----------------------------------------------------
} // end of reqShow

function GenerateTemplate()
{
    var gActiveEditor = GetCurrentEditor();
    var document = gActiveEditor.document;
    var template;
    
    /* removing or creating template */
    if((template = document.getElementById('template')) != null)
    {
        document.body.removeChild(template);
        gActiveEditor.incrementModificationCount(1);
        return;
    }
    
    reqShow();
    return;
}

function getElementText(el)
{
    if ('string' == typeof el.textContent) return el.textContent;
    if ('string' == typeof el.innerText) return el.innerText;
    return el.innerHTML.replace(/<[^>]*>/g,'');
}

// Splits the text into several lines up to 72 characters each,
// inserts [space] and " *" before each line and returns the result.
function formatCommentText(txt)
{
    if (!txt) return null;
    
    // remove leading & trailing whitespace chars as well as newlines
    txt = txt.replace(/(^\s+|\s+$)/g,""); 
    txt = txt.replace(/[\n\r]+/g," "); 
    
    txt += "\n";
    
    var text = "";
    var l = 0;
    while(l < txt.length)
    {
        txt.substr(l).match(/(.{0,71}\S|)(\s\n|\n|\s)/);
        l += RegExp.$1.length + RegExp.$2.length;
        text += space + "&nbsp;*&nbsp;" + RegExp.$1 + "<br>";
    }
    
    return text;
}
